/**
 * Appender - Adds copyrights to the copied text.
 * Exclusively on Envato Market: https://1.envato.market/appender
 *
 * @encoding        UTF-8
 * @version         1.0.1
 * @copyright       Copyright (C) 2018 - 2019 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Alexander Khmelnitskiy (info@alexander.khmelnitskiy.ua), Dmitry Merkulov (dmitry@merkulov.design)
 * @support         dmitry@merkulov.design
 **/

/** Run jQuery scripts */
( function ( $ ) {

    "use strict";

    /** Document Ready. */
    $( document ).ready( function () {

        let jsSwitcher = jQuery( '#mdp_appender_settings_js_required' );
        let beforeSwitcher = jQuery( '#mdp_appender_add_before' );
        let afterSwitcher = jQuery( '#mdp_appender_add_after' );

        /**
         * Show/hide JavaScript Required Message field.
         **/
        function ShowJavaScriptRequiredMessage() {

            if ( jsSwitcher.prop( 'checked' ) === true ) {
                jsSwitcher.closest( 'tr' ).next().show( 300 );
            } else if ( jsSwitcher.prop( 'checked' ) === false ) {
                jsSwitcher.closest( 'tr' ).next().hide( 300 );
            }
        }
        jsSwitcher.on( 'click', ShowJavaScriptRequiredMessage );
        ShowJavaScriptRequiredMessage();

        /**
         * Show/hide Text Before field.
         **/
        function ShowTextBefore() {

            if ( beforeSwitcher.prop( 'checked' ) === true ) {
                beforeSwitcher.closest( 'tr' ).next().show( 300 );
            } else if ( beforeSwitcher.prop( 'checked' ) === false ) {
                beforeSwitcher.closest( 'tr' ).next().hide( 300 );
            }
        }
        beforeSwitcher.on( 'click', ShowTextBefore );
        ShowTextBefore();

        /**
         * Show/hide Text After field.
         **/
        function ShowTextAfter() {

            if ( afterSwitcher.prop( 'checked' ) === true ) {
                afterSwitcher.closest( 'tr' ).next().show( 300 );
            } else if ( afterSwitcher.prop( 'checked' ) === false ) {
                afterSwitcher.closest( 'tr' ).next().hide( 300 );
            }
        }
        afterSwitcher.on( 'click', ShowTextAfter );
        ShowTextAfter();

        /** Initialize CSS Code Editor. */
        let css_editor;
        if ( $( '#mdp_custom_css_fld' ).length ) {

            let editorSettings = wp.codeEditor.defaultSettings ? _.clone( wp.codeEditor.defaultSettings ) : {};
            editorSettings.codemirror = _.extend(
                {},
                editorSettings.codemirror,
                {
                    indentUnit: 2,
                    tabSize: 2,
                    mode: 'css'
                }
            );

            css_editor = wp.codeEditor.initialize( 'mdp_custom_css_fld', editorSettings );

            css_editor.codemirror.on( 'change', function( cMirror ) {
                css_editor.codemirror.save(); // Save data from CodeEditor to textarea.
                $( '#mdp_custom_css_fld' ).change();
            } );
        }

        mdp_appender_unsaved = false;
    } );

} ( jQuery ) );

